#include <stdio.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>

unsigned long getaddr(char *);

int main(int argc, char **argv) {
  unsigned long addr;
  struct in_addr foo;

  if (argc!=2) {
    printf("netclass version 1.0\n");
    printf("Usage: netclass <address>\n");
    printf("\n");
    printf("          Low Address  High Address\n");
    printf("----------------------------------------\n");
    printf("Class A     0.1.0.0    126.0.0.0\n");
    printf("Class B   128.0.0.0    191.255.0.0\n");
    printf("Class C   192.0.1.0    223.255.255.0\n");
    printf("Class D   224.0.0.0    239.255.255.255\n");
    printf("Class E   240.0.0.0    247.255.255.255\n");
    printf("\nSource: \"Internetworking with TCP/IP\" by Douglas E. Comer\n");

    exit(1);
  }

  addr=getaddr(argv[1]);

  foo.s_addr=htonl(addr);
  printf("%s is ", inet_ntoa(foo));

  if (addr < getaddr("0.1.0.0")) {
    printf("RESERVED (below class A)\n");
  } else if (addr <= getaddr("126.0.0.0")) {
    printf("Class A\n");
  } else if (addr < getaddr("128.0.0.0")) {
    printf("RESERVED (class A)\n");
  } else if (addr <= getaddr("191.255.0.0")) {
    printf("Class B\n");
  } else if (addr < getaddr("192.0.1.0")) {
    printf("RESERVED (class B)\n");
  } else if (addr <= getaddr("223.255.255.0")) {
    printf("Class C\n");
  } else if (addr < getaddr("224.0.0.0")) {
    printf("RESERVED (class C)\n");
  } else if (addr <= getaddr("239.255.255.255")) {
    printf("Class D\n");
  } else if (addr <= getaddr("247.255.255.255")) {
    printf("Class E\n");
  } else {
    printf("RESERVED (above class E)\n");
  }

  exit(0);
}

unsigned long getaddr(char *in) {
  return(ntohl(inet_addr(in)));
}
